"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.upgrade = exports.init = void 0;
const fs_1 = __importDefault(require("fs"));
const path = __importStar(require("path"));
const createFile_1 = require("@/util/createFile");
const isFolderExist_1 = require("@/util/isFolderExist");
const wget_1 = require("@/util/wget");
const rootCatalog = path.join('./snp/test');
const configTemplate = ['README.md', '.github/PULL_REQUEST_TEMPLATE.md'];
const config = {
    'README.md': {
        name: 'README.md',
        filePackage: {
            instructions: 'README.md-instructions.md',
            default: 'README.md-default.md',
            extends: 'README.md-extends.md',
            custom: 'README.md-custom.md',
        },
        sequence: ['default', 'extends', 'custom'],
    },
};
const init = async ({ files, rootCatalog }) => {
    const rootDir = rootCatalog ? rootCatalog : path.dirname('./');
    const snpRootFolder = path.join(rootDir, 'snp');
    await (0, isFolderExist_1.isFolderExist)({
        folderPath: snpRootFolder,
        createFolder: true,
    });
    await (0, createFile_1.createFile)({
        filePath: `${snpRootFolder}/snp.config.json`,
        content: JSON.stringify({ version: '2.0.0', template: 'node' }),
    });
};
exports.init = init;
const upgrade = async ({ files, rootCatalog }) => {
    const fileList = Array.isArray(files) ? files : [files];
    const rootDir = rootCatalog ? rootCatalog : path.dirname('./');
    for (const file of fileList) {
        const { filePackage, sequence, name } = config[file];
        for (const key of Object.keys(filePackage)) {
            const currentPath = path.join(rootDir, filePackage[key]);
            // const content = await getContent();
            const url = `https://raw.githubusercontent.com/SebastianWesolowski/testTemplate/main/${filePackage[key]}`;
            const content = await (0, wget_1.wgetAsync)(url);
            const createdFile = await (0, createFile_1.createFile)({ filePath: currentPath, content });
            console.log({
                key,
                filePackageKey: filePackage[key],
                createdFile,
            });
        }
        // Create an array to store file contents
        const fileContents = [];
        // Read contents of each file and push into the array
        for (const sequenceFile of sequence) {
            const filePath = path.join(rootDir, filePackage[sequenceFile]);
            const content = await fs_1.default.promises.readFile(filePath, 'utf-8');
            fileContents.push(content);
        }
        const concatenatedContent = fileContents.join('\n');
        const newFilePath = path.join(rootDir, name);
        await fs_1.default.promises.writeFile(newFilePath, concatenatedContent, 'utf-8');
        ////get config
        //// join cintent
        //// write content
    }
};
exports.upgrade = upgrade;
(0, exports.init)({ files: configTemplate[0], rootCatalog }).then((r) => console.log('init'));
// upgrade({ files: configTemplate[0], rootCatalog: rootCatalog + '/snp/test' });
// try {
//    createFile({filePath: './snp/test/readme.md', content: 'lorem ipsum dolor'}).then(r =>);
//   // Handle the result here
// } catch (error) {
//   console.log(error);
//   // Handle errors here
// }
//
// try {
//   const fileContent = fs.readFileSync(inputFile, 'utf-8');
//
//   // Znajdź indeksy początku i końca sekcji do zbudowania głównego pliku
//   const startIndex = fileContent.indexOf('<!-- Zaczynamy Sekcję do Zbudowania Głównego Pliku -->');
//   const endIndex = fileContent.indexOf('<!-- Koniec Sekcji do Zbudowania Głównego Pliku -->');
//
//   if (startIndex !== -1 && endIndex !== -1 && startIndex < endIndex) {
//     // Wyodrębnij instrukcję
//     const instructionPart = fileContent.substring(0, startIndex);
//
//     // Wyodrębnij główną zawartość
//     const contentPart = fileContent.substring(startIndex, endIndex);
//
//     // Zapisz do osobnych plików
//     fs.writeFileSync(outputInstructionFile, instructionPart.trim());
//     fs.writeFileSync(outputContentFile, contentPart.trim());
//
//     console.log('Pliki zostały utworzone.');
//   } else {
//     console.log('Brak odpowiednich oznaczeń w pliku z częścią.');
//   }
// } catch (error) {
//   console.error(`Błąd odczytu pliku: ${error.message}`);
// }
