#!/usr/bin/env node
"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.init = void 0;
const path = __importStar(require("path"));
const createFile_1 = require("@/util/createFile");
const isFolderExist_1 = require("@/util/isFolderExist");
// const dir = path.dirname('./');
const rootCatalog = path.join('./snp/test');
const configTemplate = ['README.md', '.github/PULL_REQUEST_TEMPLATE.md'];
const config = {
    'README.md': {
        name: 'README.md',
        filePackage: {
            instructions: 'README.md-instructions.md',
            default: 'README.md-default.md',
            extends: 'README.md-extends.md',
            custom: 'README.md-custom.md',
        },
        sequence: ['default', 'extends', 'custom'],
    },
};
const init = async ({ files = configTemplate[0], rootCatalog, }) => {
    const rootDir = rootCatalog ? rootCatalog : path.dirname('./');
    const snpRootFolder = path.join(rootDir, 'snp');
    await (0, isFolderExist_1.isFolderExist)({
        folderPath: snpRootFolder,
        createFolder: true,
    });
    await (0, createFile_1.createFile)({
        filePath: `${snpRootFolder}/snp.config.json`,
        content: JSON.stringify({ version: '2.0.0', template: 'node' }),
    });
};
exports.init = init;
(0, exports.init)({ files: configTemplate[0], rootCatalog }).then((r) => console.log('init'));
