"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.isFileExists = void 0;
const fs_1 = __importDefault(require("fs"));
/**
 * Checks the existence of a file in the file system.
 *
 * @param {string} filePath - The path to the file whose existence is to be checked.
 * @returns {Promise<boolean>} - Returns a Promise representing whether the file exists.
 *                              Resolves to true if the file exists, and false otherwise.
 */
async function isFileExists(filePath) {
    try {
        await fs_1.default.promises.access(filePath); // Użyj fs.promises.access lub obsłuż callback
        return true;
    }
    catch (error) {
        return false;
    }
}
exports.isFileExists = isFileExists;
