"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.toCreateFile = void 0;
const fs_1 = __importDefault(require("fs"));
const isFileExists_1 = require("./isFileExists");
async function toCreateFile({ filePath, content, options = { overwriteFile: true, backupFile: true }, }) {
    const { overwriteFile, backupFile } = options;
    try {
        const fileExists = await (0, isFileExists_1.isFileExists)(filePath);
        if (backupFile && fileExists) {
            const existingContent = await fs_1.default.promises.readFile(filePath, 'utf-8');
            if (existingContent !== content.toString()) {
                const backupFilePath = filePath + '.backup';
                await fs_1.default.promises.copyFile(filePath, backupFilePath);
            }
        }
        if (((await (0, isFileExists_1.isFileExists)(filePath)) && overwriteFile) || !(await (0, isFileExists_1.isFileExists)(filePath))) {
            // If overwriteFile is true or backupFile is false, overwrite the file or create a new one
            await fs_1.default.promises.writeFile(filePath, content);
        }
    }
    catch (error) {
        throw error; // You might want to handle the error differently based on your application's needs
    }
}
exports.toCreateFile = toCreateFile;
